<?php
/*
    CREATIVE COMMONS - Attribution-No Derivative Works 3.0 Germany:
    - You may not alter, transform, or build upon this work.
    - Dieses Werk darf nicht bearbeitet oder in anderer Weise verändert werden.
*/

function getRealIP():string {
// https://stackoverflow.com/questions/3003145/how-to-get-the-client-ip-address-in-php?rq=1
  //whether ip is from share internet
  if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
      $ip_address = $_SERVER['HTTP_CLIENT_IP']; }
  //whether ip is from proxy
  elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
      $ip_address = $_SERVER['HTTP_X_FORWARDED_FOR']; }
  //whether ip is from remote address
  else {
      $ip_address = $_SERVER['REMOTE_ADDR']; }
  return $ip_address; }

function getSubmenu(array $MenuItems):string {
  global $Menu;
  global $Submenu;
  $output = '<ul id="Submenu">';
  foreach ($MenuItems as $key => $value) {
    $output .= '<li><a href="index.php?menu='.$Menu.'&amp;submenu='.$value.'"';
    $output .= ($Submenu==$value) ?' class="selected"' :'';
    $output .= '><img src="'.$Menu.'/images/menu_'.$value.'.png" alt="">';
    $button = 'L_'.ucfirst($value);
    global ${$button};
    $output .= ${$button};
    $output .= '</a></li>
    '; }
  return $output.'</ul>'; }

function getRandomString(int $chars):string {
// Taken from https://stackoverflow.com/questions/4356289/php-random-string-generator
  return substr(str_shuffle(MD5(microtime())), 0, $chars); }

function getSetup($Var):mixed {
  //echo '['.$Var.'] <br>';
  global $db;
  $SQLQuery="SELECT ".$Var." FROM ".DB_PREFIX."setup WHERE SetupID=1 LIMIT 1";
  $Result = mysqli_query($db, $SQLQuery);
  if ($Result) {
    if (mysqli_num_rows($Result)==1) {
      $temp = mysqli_fetch_assoc($Result);
      return $temp[$Var]; }
    else
      return false; }
  else
    return false; }

function getUserID($UsersName, $UsersPassword):int {
  //$UsersPassword = addslashes($UsersPassword); // Bugfix v1.2.76_019
  $hash = getUserVar($UsersName, 'UsersPassword');
  $verified = password_verify($UsersPassword, $hash);
  if ($verified)
    return true;
  else
    return false; }

function getPasswordHash($Password):string {
  return password_hash($Password, PASSWORD_DEFAULT); }

function changePassword($NewPassword):bool {
  global $db;
  // Maskieren spezieller Zeichen für die Verwendung in einer SQL-Anweisung
    $NewPassword = mysqli_real_escape_string($db, $NewPassword);
  //
    $NewPassword = getPasswordHash($NewPassword);
  $SQLQuery = "UPDATE ".DB_PREFIX."users SET
    UsersPassword = '$NewPassword'
    WHERE UsersName = '".getCurrentUserName()."'
    LIMIT 1";
  $Result = mysqli_query($db, $SQLQuery);
  if ($Result)
    return true;
  else
    return false; }

function getCurrentUserVar($Var) {
  //echo $Var.'<br>';
  global $db;
  if ($Var>0 OR $Var!='') {
    $SQLQuery = "SELECT ".$Var." FROM ".DB_PREFIX."users WHERE UsersSessionID='".session_id()."' LIMIT 1";
    $Result = mysqli_query($db, $SQLQuery);
    if ($Result) {
      if (mysqli_num_rows($Result)==1) {
        $temp = mysqli_fetch_assoc($Result);
        return $temp[$Var]; }
      else return false; }
    else return false; }
  else return false; }

function showLogInForm() {
  global $L_UsersName;
  global $L_UsersPassword;
  global $L_Button27;
  global $CharsUsersName;
  global $CharsUsersPassword;
  global $LoginMessage;
  global $L_Stay_logged_in;
  if (isset($_POST['usersname']))
    $UsersName = $_POST['usersname'];
  else
    $UsersName = '';
  if (isset($_POST['userpass']))
    $UsersPassword = $_POST['userpass'];
  else
    $UsersPassword = '';
  if (isset($LoginMessage))
    echo '<span class="ErrorMessage Small" style="padding-bottom:0.5em">
      '.$LoginMessage.'</span><br><br>';
  echo '
    <form method="post" action="index.php" accept-charset="UTF-8">
      <input type="text" autofocus id="usersname" name="usersname"
        maxlength="'.$CharsUsersName.'" value="'.$UsersName.'"
        placeholder="'.$L_UsersName.'" required ><br>
      <input type="password" id="password" name="userpass"
        maxlength="'.$CharsUsersPassword.'" value="'.$UsersPassword.'"
        placeholder="'.$L_UsersPassword.'" required><br>
      <input type="checkbox" id="StayLoggedIn" name="StayLoggedIn" value="1">
      <label for="StayLoggedIn">'.$L_Stay_logged_in.'</label><br>
      <input name="login" type="submit" value="'.$L_Button27.'" class="button"
      required>
    </form>'; }

function echoError($Text):void {
  echo '<span class="ErrorMessage">'.$Text.'</span><br>'; }

function isEmailDomainValid($email):bool {
  if (function_exists('checkdnsrr')) {
    $tempArray = explode('@', $email); // because array_pop() requires a var
    if (checkdnsrr(array_pop($tempArray)))
      return true; }
  else
    return true; }

function isEmailTLDValid($email):bool {
  $tld = array('ac', 'ad', 'ae', 'aero', 'af', 'ag', 'ai', 'al', 'am', 'an',
    'ao', 'aq', 'ar', 'as', 'at', 'au', 'aw', 'az', 'ba', 'bb', 'bd', 'be',
    'bf', 'bg', 'bh', 'bi', 'biz', 'bj', 'bm', 'bn', 'bo', 'br', 'bs', 'bt',
    'bv', 'bw', 'by', 'bz', 'ca', 'cat', 'cc', 'cd', 'cf', 'cg', 'ch', 'ci',
    'ck', 'cl', 'cm', 'cn', 'co', 'com', 'coop', 'cr', 'cu', 'cv', 'cx', 'cy',
    'cz', 'de', 'dj', 'dk', 'dm', 'do', 'dz', 'ec', 'edu', 'ee', 'eg', 'er',
    'es', 'et', 'eu', 'fi', 'fj', 'fk', 'fm', 'fo', 'fr', 'ga', 'gb', 'gd',
    'ge', 'gf', 'gg', 'gh', 'gi', 'gl', 'gm', 'gn', 'gov', 'gp', 'gq', 'gr',
    'gs', 'gt', 'gu', 'gw', 'gy', 'hk', 'hm', 'hn', 'hr', 'ht', 'hu', 'id',
    'ie', 'il', 'im', 'in', 'info', 'int', 'io', 'iq', 'ir', 'is', 'it', 'je',
    'jm', 'jo', 'jobs', 'jp', 'ke', 'kg', 'kh', 'ki', 'km', 'kn', 'kr', 'kw',
    'ky', 'kz', 'la', 'lb', 'lc', 'li', 'lk', 'lr', 'ls', 'lt', 'lu', 'lv',
    'ly', 'ma', 'mc', 'md', 'mg', 'mh', 'mil', 'mk', 'ml', 'mm', 'mn', 'mo',
    'mobi', 'mp', 'mq', 'mr', 'ms', 'mt', 'mu', 'museum', 'mv', 'mw', 'mx',
    'my', 'mz', 'na', 'name', 'nc', 'ne', 'net', 'nf', 'ng', 'ni', 'nl', 'no',
    'np', 'nr', 'nu', 'nz', 'om', 'org', 'pa', 'pe', 'pf', 'pg', 'ph', 'pk',
    'pl', 'pm', 'pn', 'pr', 'pro', 'ps', 'pt', 'pw', 'py', 'qa', 're', 'ro',
    'ru', 'rw', 'sa', 'sb', 'sc', 'sd', 'se', 'sg', 'sh', 'si', 'sj', 'sk',
    'sl', 'sm', 'sn', 'so', 'sr', 'st', 'su', 'sv', 'sy', 'sz', 'tc', 'td',
    'tf', 'tg', 'th', 'tj', 'tk', 'tl', 'tm', 'tn', 'to', 'tp', 'tr', 'travel',
    'tt', 'tv', 'tw', 'tz', 'ua', 'ug', 'uk', 'um', 'us', 'uy', 'uz', 'va',
    'vc', 've', 'vg', 'vi', 'vn', 'vu', 'wf', 'ws', 'ye', 'yt', 'yu', 'za', 'zm');
  $email = rtrim($email);
  $email = substr($email, strrpos($email, '.') + 1);
  if (!$email)
    return false;
  if (in_array(strtolower($email), $tld))
    return true;
  return false; }

function getURLWithoutFinalSlash($url):string {
https://stackoverflow.com/questions/9364242/how-to-remove-http-www-and-slash-from-url-in-php
  return trim($url, '/'); }

function getFrontendURL($Var):string {
// Function, to get frontend urls either from running script or the settings in gigkalender.ini.php, to define correct links.
  global $SetupFrontendCalendarCurrentMonthURL;
  global $SetupCalendarFrontendDetailsURL;
  global $SetupGuestbookEmailURL;
  global $SetupGuestbookFormURL; // Bugfix v1.2.80_003
  global $SetupGuestbookURL;
  global $SetupGalleryURL;
  // Get url from setup
  $setupURL = getSetup($Var);
  //$setupURL = ${$Var};
  // Get url defined in gigkalender.ini.php
  $iniURL = @${$Var};
  // Get url from currently running script
  if (isset($_SERVER['REQUEST_URI']))
    $REQUEST_URI = $_SERVER['REQUEST_URI'];
  else
    $REQUEST_URI = '';
  // Check if set in Setup or gigkalender.ini.php, otherwise set REQUEST_URI
  if ($setupURL!='')
    $URL = $setupURL;
//   elseif ($iniURL!='') $URL = $iniURL;
  else
    $URL = $REQUEST_URI;
  // Split URL into Path and Query
  $URLArray = parse_url($URL);
  //make new query string
  if (isset($URLArray['query'])) {
    $Path = str_replace("?".$URLArray['query'], "", $URL);
    $Query = @$URLArray['query'];
    // Save query vars in an array
    parse_str($Query, $QueryArray);
    // Remove GigKalender vars from Query
    unset($QueryArray['news_page']);
    unset($QueryArray['gb_page']);
    unset($QueryArray['album']);
    unset($QueryArray['image']);
    if (count($QueryArray)>0) {
      $Query = http_build_query($QueryArray, '', '&amp;');
      $Query = '?'.$Query; }
    else $Query = ''; }
  else {
    $Path = $URL;
    $Query = ''; }
  // calculate the URL to return
  if ($Var=='SetupCalendarFrontendDetailsURL') {
    global $Timestamp;
    if ($Timestamp!='') { // for month view
      $URL = $Path;
      if (preg_match('|\?|', $URL)) $URL .= '&timestamp='.$Timestamp;
        else $URL .= '?timestamp='.$Timestamp; }
    else { // for list view
      $URL = $Path.$Query;
      if (preg_match ( '|\?|', $URL )) $URL .= '&GigID=';
        else $URL .= '?GigID='; }}
  elseif ($Var=='SetupFrontendCalendarCurrentMonthURL') {
      $URL = $Path; }
  elseif ($Var=='SetupGalleryFrontendURL') {
    $URL = $Path; }
  elseif ($Var=='SetupGuestbookURL') {
    $URL = $Path.$Query; }
  elseif ($Var=='SetupGuestbookFormURL') {
    $URL = $Path.$Query;
    if (preg_match('|\?|', $URL)) $URL .= '&gb_page=form';
      else $URL .= '?gb_page=form'; }
  elseif ($Var=='SetupGuestbookEmailURL') {
    $URL .= $Query;
    if (preg_match('|\?|', $URL)) $URL .= '&amp;';
      else $URL .= '?'; }
  elseif ($Var=='SetupNewsFrontendURL') {
    $URL = $Path.$Query; }
  if ($URL=="") echo "ERROR: Empty URL from getFrontendURL().";
  return $URL; }

function getPagination ($URL, $NumberPages, $CurrentPage, $Sorting, $PageVar):string {
  $maxNumberPageButtons = 9; // 9, uneven, greater 5
  // If even, then increment
  if ($maxNumberPageButtons%2==0) $maxNumberPageButtons++;
  // If too few buttons defined, set maximum number to 7
  if ($maxNumberPageButtons < 7) $maxNumberPageButtons = 7;
  if ($CurrentPage=="") {
    if ($Sorting="ASC") $CurrentPage = 1;
    elseif ($Sorting="DESC") $CurrentPage = $NumberPages; }
  $Result = '<div class="pagination">';
  $ButtonsHTML = array(); // Holds HTML for each button, for later sorting
  // Prepare a new URL for query strings
    if (preg_match('|\?|', $URL)) $newURL = $URL.'&'.$PageVar."=";
      else $newURL = $URL.'?'.$PageVar."=";
  // Check whether short or long pagination
  if ($NumberPages <= $maxNumberPageButtons) { // Short Pagination, e.g. [1 2 3 4 5 6 7]
      // Page Buttons
      $index = $NumberPages;
      while ($index > 0) {
        if ($index==$NumberPages) { // First Page Button
          if ($Sorting=="ASC")
            $shortPaginationURL = $newURL.$index;
          else
            $shortPaginationURL = $URL; }
        elseif ($index==1) { // Last Page Button
          if ($Sorting=="ASC")
            $shortPaginationURL = $URL;
          else
            $shortPaginationURL = $newURL."1"; }
        // Center Buttons
        else $shortPaginationURL = $newURL.$index;
        if ($CurrentPage!=$index)
          array_push($ButtonsHTML, '<a href="'.$shortPaginationURL.'">'.$index--.'</a>');
        else
          array_push($ButtonsHTML, '<a class="current">'.$index--.'</a>'); }}
  else { // Long Pagination, e.g. [1 … 5 6 7 … 11]
      $maxNumberPageButtons = $maxNumberPageButtons-4;
      $index = $maxNumberPageButtons;
      // First Page Button
        if ($CurrentPage==$NumberPages)
          array_push($ButtonsHTML, '<a class="current">'.$NumberPages--.'</a>');
        else
          if ($Sorting=="ASC")
            array_push($ButtonsHTML, '<a href="'.$newURL.$NumberPages.'">'.$NumberPages--.'</a>');
          else
            array_push($ButtonsHTML, '<a href="'.$URL.'">'.$NumberPages--.'</a>');
      // Hidden Buttons on Left side
        $hiddenButtons = ($NumberPages-$CurrentPage)-(($maxNumberPageButtons-1)/2);
        if ($hiddenButtons>1) {
          array_push($ButtonsHTML, '<a class="passive">…</a>');
          $NumberPages = $NumberPages-$hiddenButtons; }
        else {
          if ($CurrentPage!=$NumberPages)
            array_push($ButtonsHTML, '<a href="'.$newURL.$NumberPages.'">'.$NumberPages--.'</a>');
          else
            array_push($ButtonsHTML, '<a class="current">'.$NumberPages--.'</a>');}
      // Center Buttons
      if ($hiddenButtons > 1 AND $NumberPages<$maxNumberPageButtons+2) $NumberPages = $maxNumberPageButtons+2;
      while ($NumberPages > 0 AND $index > 0) {
        if ($CurrentPage!=$NumberPages)
          array_push($ButtonsHTML, '<a href="'.$newURL.$NumberPages.'">'.$NumberPages--.'</a>');
        else
          array_push($ButtonsHTML, '<a class="current">'.$NumberPages--.'</a>');
        $index--; }
      // Hidden Buttons on Right side
        $hiddenButtons = $NumberPages-1;
        if ($hiddenButtons>1)
          array_push($ButtonsHTML, '<a class="passive">…</a>');
        else {
          if ($CurrentPage!=$NumberPages)
            array_push($ButtonsHTML, '<a href="'.$newURL.$NumberPages.'">'.$NumberPages--.'</a>');
          else
            array_push($ButtonsHTML, '<a class="current">'.$NumberPages--.'</a>'); }
      // Last Page Button
        if ($CurrentPage!=1)
          if ($Sorting=="ASC")
            array_push($ButtonsHTML, '<a href="'.$URL.'">1</a>');
          else
            array_push($ButtonsHTML, '<a href="'.$newURL.'1">1</a>');
        else
          array_push($ButtonsHTML, '<a class="current">1</a>'); }
  if ($Sorting=="ASC") $ButtonsHTML = array_reverse($ButtonsHTML);
  $Result .= implode("", $ButtonsHTML); // array to string
  return $Result.'</div>'; }

function isUserAdmin():bool {
  global $db;
  $SQLQuery='SELECT UsersRoleID FROM '.DB_PREFIX.'users WHERE UsersSessionID="'.session_id().'"';
  $Result = mysqli_query($db, $SQLQuery);
  $temp = mysqli_fetch_assoc($Result);
  if (isset($temp['UsersRoleID']) AND $temp['UsersRoleID'] == "Admin") // Bugfix: v1.2.80_172
    return true;
  else
    return false; }

function getFileNames($directory, $fileTypes="/*.*"):array {
  // returns just the names of all files in a directory
  // optional results can get filtered by filetypes via regular expression
  $files = array();
  $files = glob($directory.$fileTypes, GLOB_BRACE);
  $count = count($files); // Dateien zählen
  for ($i=0; $i<$count; $i++)
    $files[$i] = basename($files[$i]); // remove paths
  array_multisort($files);
  return $files; }

function formatFileSize($bytes, $decimals):string {
  // http://php.net/manual/de/function.filesize.php#106569
  $sz = 'BKMGTP';
  $factor = floor((strlen($bytes) - 1) / 3);
  if ($factor==0) $appendix = '';
  else $appendix = 'iB';
  return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) .' '. @$sz[$factor].$appendix; }

function getDateAndTimeByTimestamp($Timestamp):string {
  if ($Timestamp!='0' AND $Timestamp!='')
    return date(USERSBACKENDDATEFORMAT, $Timestamp).' '.date(USERSBACKENDTIMEFORMAT, $Timestamp);
  else
    return '-'; }

function logoutInactiveUsers():void {
  global $db;
  $SetupGeneralBackendMaximumInactivityTime = SETUPGENERALBACKENDMAXIMUMINACTIVITYTIME;
  if ($SetupGeneralBackendMaximumInactivityTime<1)
    $SetupGeneralBackendMaximumInactivityTime = 1;
  $Diff = time()-($SetupGeneralBackendMaximumInactivityTime*60);
  $SQLQuery="UPDATE ".DB_PREFIX."users SET
    UsersSessionID=NULL
    WHERE UsersLastActivity<'".$Diff."'";
  mysqli_query($db, $SQLQuery); }

function editCurrentUser($EmailAddress, $Language, $Timezone, $BackendDateFormat,
  $BackendTimeFormat, $UsersBackendFirstWeekday):bool {
  global $db;
  // HTML- und PHP-Tags entfernen
    $EmailAddress = strip_tags($EmailAddress);
    $Language = strip_tags($Language);
  // Maskieren spezieller Zeichen für die Verwendung in einer SQL-Anweisung
    $EmailAddress = mysqli_real_escape_string($db, $EmailAddress);
  $SQLQuery = "UPDATE ".DB_PREFIX."users SET
    UsersEmailAddress = '$EmailAddress',
    UsersLanguage = '$Language',
    UsersTimezone = '$Timezone',
    UsersBackendDateFormat = '$BackendDateFormat',
    UsersBackendTimeFormat = '$BackendTimeFormat',
    UsersBackendFirstWeekday = '$UsersBackendFirstWeekday'
    WHERE UsersName = '".getCurrentUserName()."'
    LIMIT 1";
  $Result = mysqli_query($db, $SQLQuery);
  if ($Result)
    return true;
  else
    return false; }

function getFirstWeekdaySelector($name, $selected):string {
// name = name of the form input field
// selected = integer of selected weekday
// ISO-8601: 1=Monday, 7=Sunday
// https://www.php.net/manual/de/function.date.php
  $Weekdays = array(1 => 'Monday', 'Tuesday', 'Wednesday', 'Thursday',
    'Friday', 'Saturday', 'Sunday');
  $output = '<select name="'.$name.'">';
  foreach ($Weekdays as $key => $value) {
    $output .='<option value="'.$key.'"';
    $output .= ($key==$selected ? ' selected' : '');
    $output .= '>'.$GLOBALS['L_'.$value].'</option>'; }
  return $output.='</select>'; }

function addUser($Name, $RoleID, $Password, $EmailAddress, $SessionID,
  $Language, $Timezone, $UsersBackendDateFormat, $UsersBackendTimeFormat,
  $UsersBackendFirstWeekday, $LastActivity, $CalendarBackendListCols,
  $CalendarBackendListChars, $CalendarBackendFormAttributes, $RightEmail,
  $RightNewsAdd, $RightNewsEdit, $RightNewsDelete, $RightCMS,
  $RightGuestbookEdit, $RightGuestbookDelete, $RightGuestbookComment):bool {
  global $db;
  // Maskieren spezieller Zeichen für die Verwendung in einer SQL-Anweisung
    $Name = mysqli_real_escape_string($db, $Name);
    $Password = mysqli_real_escape_string($db, $Password);
    $EmailAddress = mysqli_real_escape_string($db, $EmailAddress);
  // Leere numerische Variablen als NULL definieren
    if ($LastActivity=='') $LastActivity="NULL";
    if ($CalendarBackendListChars=='') $CalendarBackendListChars="22";
    if ($RightEmail=='') $RightEmail=0;
    if ($RightNewsAdd=='') $RightNewsAdd=0;
    if ($RightNewsEdit=='') $RightNewsEdit=0;
    if ($RightNewsDelete=='') $RightNewsDelete=0;
  if (!isExistingUser($Name)) {
    $SQLQuery =
      "INSERT INTO ".DB_PREFIX."users
      (UsersName, UsersRoleID, UsersPassword, UsersEmailAddress, UsersSessionID,
        UsersLanguage, UsersTimezone, UsersBackendDateFormat,
        UsersBackendTimeFormat, UsersBackendFirstWeekday, UsersLastActivity,
        UsersCalendarBackendListCols, UsersCalendarBackendListChars,
        UsersCalendarBackendFormAttributes, UsersRightEmail, UsersRightNewsAdd,
        UsersRightNewsEdit, UsersRightNewsDelete, UsersRightCMS,
        UsersRightGuestbookEdit, UsersRightGuestbookDelete,
        UsersRightGuestbookComment)
      VALUES
      ('$Name', '$RoleID', '$Password', '$EmailAddress', '$SessionID',
        '$Language', '$Timezone', '$UsersBackendDateFormat',
        '$UsersBackendTimeFormat', $UsersBackendFirstWeekday, $LastActivity,
        '$CalendarBackendListCols', $CalendarBackendListChars,
        '$CalendarBackendFormAttributes', $RightEmail, $RightNewsAdd,
        $RightNewsEdit, $RightNewsDelete, $RightCMS, $RightGuestbookEdit,
        $RightGuestbookDelete, $RightGuestbookComment)";
    $Result = mysqli_query($db, $SQLQuery);
    if ($Result) // user got added
      return true;
    else // addings user failed
      return false; }
  else // user already exists
    return false; }

function setUserVar($Var, $Value):bool {
  global $db;
  $SQLQuery = "UPDATE ".DB_PREFIX."users
    SET $Var = '$Value'";
  if (mysqli_query($db, $SQLQuery))
    return true;
  else
    return false; }

function getTimezoneSelector($name, $selected):string {
// inspired by https://www.php.net/manual/en/function.timezone-identifiers-list.php#122940
// name = Name of the option tag
// selected = string of selected timezone
  $TimezonesArray = timezone_identifiers_list();
  $output = '<select name="'.$name.'">';
  foreach ($TimezonesArray as $key => $value) {
    $output .='<option value="'.$value.'"';
    $output .= ($value==$selected ? ' selected' : '');
    $output .= '>'.$value.'</option>'; }
  return $output.='</select>'; }

function isUserLoggedIn():bool {
  global $db, $session_id;
  $SQLQuery="SELECT UsersID FROM ".DB_PREFIX."users
    WHERE UsersSessionID='".$session_id."'
    LIMIT 1";
  $Result= mysqli_query($db, $SQLQuery);
  if ($Result)
    return (mysqli_num_rows($Result)==1);
  else return false; }

function showLogOutForm():void {
  global $L_012;
  global $L_020;
  echo '<b>'.$L_020.' '.getCurrentUserName().'!</b>
    <form method="post" action="index.php" accept-charset="UTF-8">
      <fieldset>
        <input name="logout" type="submit" value="'.$L_012.'" class="button" />
      </fieldset>
    </form>'; }

function translateLanguageVarString($String):String {
  $Array = explode( ', ', $String);
  for ($i=0; $i<count($Array); $i++) {
    global ${'L_'.$Array[$i]};
    $Array[$i] = ${'L_'.$Array[$i]}; }
  return implode(', ', $Array); }

function convertISO8601ToTimestamp($ISO8601) {
  global $L_ERROR_Invalid_date;
  if ($ISO8601>0) {
    $eregStr =  '/([0-9]{4})-'. // centuries & years CCYY-
                '([0-9]{2})-'. // months MM-
                '([0-9]{2})'.  // days DD
                'T'.           // separator T
                '([0-9]{2}):'. // hours hh:
                '([0-9]{2}):'. // minutes mm:
                '([0-9]{2})(\.[0-9]+)?'. // seconds ss.ss...
                '(Z|[+\-][0-9]{2}:?[0-9]{2})?/'; // Z to indicate UTC, -/+HH:MM:SS.SS... for local tz's
              if(preg_match($eregStr,$ISO8601,$regs)) {
                $temp = strtotime("$regs[1]-$regs[2]-$regs[3] $regs[4]:$regs[5]:$regs[6]Z");
              // not utc
                if($regs[8] != 'Z') {
                  $op = substr($regs[8],0,1);
                  $h = substr($regs[8],1,2);
                  $m = substr($regs[8],strlen($regs[8])-2,2);
                  if($op == '-')
                    $temp = $temp+($h*3600+$m*60);
                  elseif($op == '+')
                    $temp = $temp-($h*3600+$m*60); }
              return $temp; }
            else // OpenOffice JJJJ-MM-TT HH:MM:SSZ
            {
              $eregStr =  '/([0-9]{4})-'. // centuries & years CCYY-
                          '([0-9]{2})-'. // months MM-
                          '([0-9]{2})'.  // days DD
                          ' '.           // separator ' '
                          '([0-9]{2}):'. // hours hh:
                          '([0-9]{2}):'. // minutes mm:
                          '([0-9]{2})(\.[0-9]+)?'. // seconds ss.ss...
                          '(Z|[+\-][0-9]{2}:?[0-9]{2})?/'; // Z to indicate UTC, -/+HH:MM:SS.SS... for local tz's
              if(preg_match($eregStr,$ISO8601,$regs)) {
              $temp = strtotime("$regs[1]-$regs[2]-$regs[3] $regs[4]:$regs[5]:$regs[6]Z");
              // not utc
                if($regs[8]!='Z') {
                  $op = substr($regs[8],0,1);
                  $h = substr($regs[8],1,2);
                  $m = substr($regs[8],strlen($regs[8])-2,2);
                  if($op == '-')
                    $temp = $temp+($h*3600+$m*60);
                  elseif($op == '+')
                    $temp = $temp-($h*3600+$m*60); }
              return $temp; }
            else { // OpenOffice JJJJ-MM-TT
              $eregStr =  '/([0-9]{4})-'. // centuries & years CCYY-
                          '([0-9]{2})-'. // months MM-
                          '([0-9]{2})/';  // days DD
              if(preg_match($eregStr,$ISO8601,$regs)) {
                $temp = strtotime("$regs[1]-$regs[2]-$regs[3] 0:0:0Z");
                return $temp; }
              else { // Timestamp
                $eregStr =  '/([0-9]{9,10})/'; // Timestamp
                if(preg_match($eregStr,$ISO8601,$regs))
                  return $regs[0];
                else {
                  echoError($L_ERROR_Invalid_date.' ('.$ISO8601.')');
                  return false; }}}}}
  else
    return ''; }

function startTime() {
  $timeExplode = explode(" ", microtime());
  return $timeExplode[1] + $timeExplode[0]; }

function endTime($timer) {
  $timeExplode = explode(" ", microtime());
  $time = $timeExplode[1] + $timeExplode[0];
  $finish = $time-$timer;
  $endTime = sprintf("%4.3f", $finish);
  return $endTime; }

function convertTimestampToISO8601($Timestamp) {
  if ($Timestamp>0) {
    // PHP4
      $temp = date('Y-m-d\TH:i:sO', $Timestamp);
      $String = substr($temp, 0, 22).':'.substr($temp, 22);
      return $String;
    // PHP5
      // return date('c',$Timestamp);
  }
  else
    return ''; }

function clearCache():void {
  $Path = str_replace('\\','/', __FILE__);
  $Path = str_replace('functions/standard.php', '', $Path);
  emptyDirectory($Path.'cache/'); }

function setSetupVar($Var, $Value):bool {
  global $db;
  $SQLQuery = "UPDATE ".DB_PREFIX."setup SET $Var='$Value'";
  $Result = mysqli_query($db, $SQLQuery);
  if ($Result)
    return true;
  else
    return false; }

function isUserUser():bool {
  global $db;
  $SQLQuery = "SELECT UsersRoleID
    FROM ".DB_PREFIX."users
    WHERE UsersSessionID='".session_id()."'";
  $Result = mysqli_query($db, $SQLQuery);
  $temp = mysqli_fetch_assoc($Result);
  if ($temp['UsersRoleID']=="User")
    return true;
  else
    return false; }

function logout() {
  global $db;
  $SQLQuery="UPDATE ".DB_PREFIX."users
    SET UsersSessionID=NULL
    WHERE UsersSessionID='".session_id()."'";
  mysqli_query($db, $SQLQuery);
  session_destroy(); }

function getCurrentUserName() {
  global $db;
  $SQLQuery="SELECT UsersName
    FROM ".DB_PREFIX."users
    WHERE UsersSessionID='".session_id()."'
    LIMIT 1";
  $Result = mysqli_query($db, $SQLQuery);
  if (mysqli_num_rows($Result)==1) {
    $temp = mysqli_fetch_assoc($Result);
    return $temp['UsersName']; }
  else
    return false; }

function loginUser($UsersID) {
  global $db;
  $SQLQuery = "UPDATE ".DB_PREFIX."users SET UsersSessionID='".session_id()."' WHERE UsersID=".$UsersID;
  mysqli_query($db, $SQLQuery); }

function getUserVar($UsersName, $Var) {
  global $db;
  // Maskieren spezieller Zeichen für die Verwendung in einer SQL-Anweisung
    $UsersName = mysqli_real_escape_string($db, $UsersName);
  $SQLQuery = "SELECT ".$Var."
    FROM ".DB_PREFIX."users
    WHERE UsersName='".$UsersName."'
    LIMIT 1";
  $Result = mysqli_query($db, $SQLQuery);
  if (mysqli_num_rows($Result)==1) {
    $temp=mysqli_fetch_assoc($Result);
    return $temp[$Var]; }
  else
    return false; }

function updateUserActivity():void {
  global $db;
  $SQLQuery="UPDATE ".DB_PREFIX."users SET
    UsersLastActivity=".time()."
    WHERE UsersName='".getCurrentUserName()."' LIMIT 1";
  mysqli_query($db, $SQLQuery); }

function isExistingUser($Username):bool {
  global $db;
  $Username = strtolower($Username);
  $SQLQuery = 'SELECT * FROM '.DB_PREFIX.'users WHERE UsersName='.$Username;
  $Result = mysqli_query($db, $SQLQuery);
  if (!$Result)
   return false;
  else
    return true; }

function getCurrentURL():string {
  // Taken from https://stackoverflow.com/questions/6768793/get-the-full-url-in-php
  return (isset($_SERVER['HTTPS']) AND $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]"; }

function isDatabasePresent():bool {
  global $db;
  if (mysqli_select_db($db, DB_NAME)) return true;
    else return false; }

function writeToCache($Filename, $Content) {
  echo $Content;
  global $GigKalenderPath;
  $Path = 'cache/';
  if (!is_dir($Path))
    mkdir($Path, 0755);
  $fp = fopen($Path.$Filename, "w+");
  fwrite($fp, $Content); }

function getDaysOfAMonth ($Month, $Year):int {
  $UnixTimestamp = mktime(0, 0, 0, $Month, 1 , $Year);
  return date('t', $UnixTimestamp); }

function emptyDirectory ($strDir) {
  $strDir .= '/'; // v1.2.77_023
  if (is_dir($strDir)) {
    $oDir = dir( $strDir );
    while (false!==($strFile=$oDir->read())) {
      if ($strFile!='.' AND $strFile!='..' AND !is_link($strDir.$strFile)) {
        if (is_file($strDir.$strFile)) {
          if (@unlink($strDir.$strFile))      {
          }
          else {
            echoError('ERROR: File NOT deleted! ('.$strFile.')'); }}
        else {
          if(is_dir($strDir.$strFile)) {
            emptyDirectory($strDir.$strFile.'/');
            rmdir($strDir.$strFile); }}}}
    $oDir->close(); }}

function getNameOfMonthFromNumberOfMonth ($Month):String {
  switch ($Month) {
    case 1: return $GLOBALS['L_January'];
    case 2: return $GLOBALS['L_February'];
    case 3: return $GLOBALS['L_March'];
    case 4: return $GLOBALS['L_April'];
    case 5: return $GLOBALS['L_May'];
    case 6: return $GLOBALS['L_June'];
    case 7: return $GLOBALS['L_July'];
    case 8: return $GLOBALS['L_August'];
    case 9: return $GLOBALS['L_September'];
    case 10: return $GLOBALS['L_October'];
    case 11: return $GLOBALS['L_November'];
    case 12: return $GLOBALS['L_December'];
    default: return 'ERROR'; }}

function getAnonymIp($ip) {
  // Taken from http://www.selfphp.de/code_snippets/code_snippet.php?id=134
  return preg_replace('/[0-9]+\z/', 'x', $ip); }

function checkEmail ($email) {
  //$email = strtolower($email);
  //if (preg_match('/^[a-z0-9\._-]+@+[a-z0-9\._-]+\.+[a-z]{2,4}$/', $email)
    //AND isEmailTLDValid($email)
    //AND isEmailDomainValid($email))
  if (filter_var($email, FILTER_VALIDATE_EMAIL))
     return true;
  else
     return false; }

function checkURL ($url) {
  return filter_var($url, FILTER_VALIDATE_URL); }

function editUser ($UsersName, $UsersRoleID, $UsersCurrentPassword,
  $UsersEmailAddress, $UsersNameOld, $UsersLanguage,
  $UsersBackendCalendarListCols, $UsersRightEmail, $UsersRightNewsAdd,
  $UsersRightNewsEdit, $UsersRightNewsDelete) {
  global $db;
  // HTML-Tags entfernen
    $UsersName = strip_tags($UsersName);
    $UserCurrentsPassword = strip_tags($UsersCurrentPassword);
    $UsersEmailAddress = strip_tags($UsersEmailAddress);
    $UsersNameOld = strip_tags($UsersNameOld);
  // Maskieren spezieller Zeichen für die Verwendung in einer SQL-Anweisung
    $UsersName = mysqli_real_escape_string($db, $UsersName);
    $UsersCurrentPassword = mysqli_real_escape_string($db, $UsersCurrentPassword);
    $UsersEmailAddress = mysqli_real_escape_string($db, $UsersEmailAddress);
    $UsersNameOld = mysqli_real_escape_string($db, $UsersNameOld);
  // Leere numerische Variablen als NULL definieren
    //if ( $UsersLastActivity=='' ) $UsersLastActivity="NULL";
    if ( $UsersRightEmail=='' ) $UsersRightEmail=0;
    if ( $UsersRightNewsAdd=='' ) $UsersRightNewsAdd=0;
    if ( $UsersRightNewsEdit=='' ) $UsersRightNewsEdit=0;
    if ( $UsersRightNewsDelete=='' ) $UsersRightNewsDelete=0;
  $SQLQuery = "UPDATE ".DB_PREFIX."users SET
    UsersName = '$UsersName',
    UsersRoleID = '$UsersRoleID',
    UsersCurrentPassword = '$UsersCurrentPassword',
    UsersEmailAddress = '$UsersEmailAddress',
    UsersLanguage = '$UsersLanguage',
    UsersBackendCalendarListCols = '$UsersBackendCalendarListCols',
    UsersRightEmail = $UsersRightEmail,
    UsersRightNewsAdd = $UsersRightNewsAdd,
    UsersRightNewsEdit = $UsersRightNewsEdit,
    UsersRightNewsDelete = $UsersRightNewsDelete
    WHERE UsersName = '$UsersNameOld'
    LIMIT 1";
  $Result = mysqli_query($db, $SQLQuery);
  if ($Result) { return true; }
  else {return false;}
}
?>